#!/bin/sh

# We have configured the syslog application on this device to write logs to this path
SYSLOG_PATH="$1"

# This path should be a symlink pointing to Continuous_Syslog.txt in the current monitoring session.
# If there is no current monitoring session, this link should not exist.
CONT_SYSLOG_PATH="/usr/local/packages/Support_ACAP/localdata/current_continuous_syslog.txt"

# Check that the syslog file exists, that the continuous syslog file is a symlink and that
# the symlink points to a valid file.
if [ -f "$SYSLOG_PATH" ] && [ -L "$CONT_SYSLOG_PATH" ] && [ -e "$CONT_SYSLOG_PATH" ]; then
  # Append contents of supacap.log to the current monitoring session's Continuous_Syslog.txt
  cat "$SYSLOG_PATH" >> "$CONT_SYSLOG_PATH"
fi
