#!/bin/sh

# Removes a Network Device Test rule from storage.

set -e

if [ "$#" -ne 2 ]; then
  exit
fi

rule_ip="$1"
rule_port="$2"

cd /usr/local/packages/Support_ACAP/localdata
if [ "$?" -ne "0" ]; then exit; fi

ip_match="no"
port_match="no"

current_ip="none"
current_port="none"
current_timer="none"
current_fails="none"
current_name="none"

while read line; do
  action="${line%:*}"

  case $action in
    N)
      current_ip="${line#N:}"
    ;;
    P)
      current_port="${line#P:}"
    ;;
    T)
      current_timer="${line#T:}"
    ;;
    F)
      current_fails="${line#F:}"
    ;;
    I)
      current_name="${line#I:}"
    ;;
  esac

  if [ "$action" == "I" ]; then
    if [ "$current_ip" == "$rule_ip" ] && [ "$current_port" == "$rule_port" ]; then
      continue
    else
      echo "N:$current_ip" >> tmp.txt
      echo "P:$current_port" >> tmp.txt
      echo "T:$current_timer" >> tmp.txt
      echo "F:$current_fails" >> tmp.txt
      echo "I:$current_name" >> tmp.txt
    fi
  fi
done < nc_rules.txt

if [ -f tmp.txt ]; then
  mv -f tmp.txt nc_rules.txt
else
  rm nc_rules.txt
fi
