#!/bin/sh

# ========= When calling with start ===========
# Getting the recording ID of the continous recording to be found
REC_ID="$1"
# Should be given as SD_DISK or NETWORKSHARE or something simple as that
SECONDARY_STORAGE="$2"
# The serial number of the device
SERIAL_NUMBER="$3"

# ========= When calling with stop ===========
WIRESHARK_DESTINATION="$1"
STOP_SERIAL_NBR="$2"
STOP_REC_ID="$3"

COMMAND="$4"

# The directory where the actual recording is stored
PATH_TO_REC="$(dirname /var/spool/storage/*/*/*/$REC_ID)/$REC_ID"

PATH_TO_ERROR_OR_MSG="/usr/local/packages/Support_ACAP/localdata/wireshark_session_talk.txt"

COLLECT_SCRIPT="/usr/local/packages/Support_ACAP/collect_wireshark_sessions.sh"

# Under this path the recording will be stored
DIR_TO_SESSION="/var/spool/storage/$SECONDARY_STORAGE/Support_ACAP_$SERIAL_NUMBER/$REC_ID"

if [ "$COMMAND" == "start" ]; then

	if echo "$SECONDARY_STORAGE" | grep "Network" >/dev/null;
	then
		PATH_TO_REC="$(dirname /var/spool/storage/$SECONDARY_STORAGE/axis-$SERIAL_NUMBER/*/*/$REC_ID)/$REC_ID"
	fi

	if mkdir -p $DIR_TO_SESSION; then
		#echo "created the directory: $DIR_TO_SESSION... now cd to it.." > $PATH_TO_ERROR_OR_MSG
		cd $DIR_TO_SESSION
		echo "S:$(date)" > wireshark_signature.txt
		echo "P:$DIR_TO_SESSION" >> wireshark_signature.txt

# ================= You can't make symlinks on vfat (FAT16/FAT32) partitions. Only EXT4 will work! ======================
		filename_of_server_report="Server_report_$(date +%Y%m%d_%I%M%S)_start.txt"

		if ln -s "$PATH_TO_REC" 2>/dev/null; then
			# ================= The architecture supports symbolic links ======================
			echo "Symbolic link included" > archive_info.txt
		else
			echo "No symbolic link included" > archive_info.txt
		fi

    (
      $COLLECT_SCRIPT $SERIAL_NUMBER
      gen_serverreport.sh > "$filename_of_server_report"
      pcapdump eth0 "$DIR_TO_SESSION/pcapdump.pcap"
    ) &

	else
		echo "cd error" >> $PATH_TO_ERROR_OR_MSG
	fi

elif [ "$COMMAND" == "stop" ]; then
	#statements
	# In this case the first argument will contain the correct path
	# an the second argument will be the serial number
	if cd $WIRESHARK_DESTINATION; then

		echo "E:$(date)" >> wireshark_signature.txt
		echo "Commencing..." > zip_info.txt # If this file exists, the ACAP regards this session as "under construction"

		# Collecting
		(
			$COLLECT_SCRIPT $STOP_SERIAL_NBR
			gen_serverreport.sh > Server_report_$(date +%Y%m%d_%I%M%S)_stop.txt
			/usr/local/packages/Support_ACAP/zip_until_no_warning.sh "$STOP_REC_ID" "$PATH_TO_REC"
		) &
	fi
fi

exit 0
