#!/bin/sh
# Sometimes the ZIP generated by the zip program are corrupt, this script is created
# to tackle the problem by continously re-zipping until no warnings are detected.

# The currect directory should have been set already
# zip wireshark_archive.zip $STOP_REC_ID $STOP_REC_ID/* $STOP_REC_ID/*/* trace.pcap Server_report_*
STOP_REC_ID="$1"

PATH_TO_REC="$2"

LIMIT_ATTEMPTS=50 # We dont want to get stuck in a while loop for ever..
ATTEMPTS_COUNT=0

echo "Zip is under construction...please wait!" > zip_info.txt

WARNINGS_THERE=1

SYMBOLIC_LINK=1

if grep "No symbolic link" archive_info.txt >/dev/null;
then
  SYMBOLIC_LINK=0
fi

while [ $WARNINGS_THERE -gt 0 ] && [ $ATTEMPTS_COUNT -lt $LIMIT_ATTEMPTS ]; do
  # keep re-zipping until there are no warnings
  WARNINGS_THERE=0

  rm -f wireshark_archive.zip

  if [ $SYMBOLIC_LINK -gt 0 ];
  then
    zip wireshark_archive.zip $STOP_REC_ID $STOP_REC_ID/* $STOP_REC_ID/*/* trace.pcap Server_report_* > zip_stdout.txt
  else
    THIS_FULL_PATH=$(pwd)

    zip -r wireshark_archive.zip trace.pcap Server_report_* > zip_stdout.txt

    if cd $PATH_TO_REC && cd ..;
    then
      zip -r $THIS_FULL_PATH/wireshark_archive.zip $STOP_REC_ID >> $THIS_FULL_PATH/zip_stdout.txt
      cd $THIS_FULL_PATH
    fi

  fi

  while read line; do
    if echo "$line" | grep "warning" >/dev/null;
    then
      WARNINGS_THERE=1
    fi
  done < zip_stdout.txt

  ATTEMPTS_COUNT=$((ATTEMPTS_COUNT+1))
done

rm zip_info.txt # Marks the finish

exit 0
